############ Nothing below here should need to be changed ############ 

LDFLAGS:=

# If config or local makefile changes: Nuke it from orbit
ALLDEP:=$(wildcard $(BASEDIR)/config/*.mk) Makefile   

ifeq ($(TARGET),host)
  OS:=$(NATIVE_OS)
  CFLAGS:=$(NATIVE_GCC_CFLAGS)
  CPPFLAGS:=$(NATIVE_GCC_CPPFLAGS)
  LDFLAGS:=$(NATIVE_GCC_LDFLAGS)
  DEFINES:=$(NATIVE_GCC_DEFINES)
  THUMB:=$(NATIVE_GCC_THUMB)
  OPTS:=$(NATIVE_GCC_OPTS)
  DEBUGS:=$(NATIVE_GCC_DEBUGS)
  GCC:=$(NATIVE_GCC)
  GPP:=$(NATIVE_GPP)
  LD:=$(NATIVE_LD)
  OBJCOPY:=$(NATIVE_OBJCOPY)
  ARCH_CODE:=$(NATIVE_ARCH_CODE)
  DOXYGEN:=$(NATIVE_DOXYGEN)
else                     # assume body unless TARGET=host
  OS:=$(CROSS_OS)
  CFLAGS:=$(CROSS_GCC_CFLAGS)
  CPPFLAGS:=$(CROSS_GCC_CPPFLAGS)
  LDFLAGS:=$(CROSS_GCC_LDFLAGS)
  DEFINES:=$(CROSS_GCC_DEFINES)
  THUMB:=$(CROSS_GCC_THUMB)
  OPTS:=$(CROSS_GCC_OPTS)
  DEBUGS:=$(CROSS_GCC_DEBUGS)
  GCC:=$(CROSS_GCC)
  GPP:=$(CROSS_GPP)
  LD:=$(CROSS_LD)
  OBJCOPY:=$(CROSS_OBJCOPY)
  ARCH_CODE:=$(CROSS_ARCH_CODE)
  DOXYGEN:=$(CROSS_DOXYGEN)
endif
CPPFLAGS+=-I$(INCLUDEDIR) 
CFLAGS+=-I$(INCLUDEDIR) 

SKETCH_EXTRA_CPPFLAGS=-DSKETCH_BUILD_DATE=`date -u +0x%Y%m%d` -DSKETCH_BUILD_TIME=`date -u +0x%H%M%S` -DSKETCH_ARCH_CODE=$(ARCH_CODE)

# Pattern rule for c files
$(OBJDIR)/%.o:	%.c $(ALLDEP) $(OBJDIR)/%.d
	$(GCC) $(OPTS) $(DEBUGS) $(CFLAGS) $(DEFINES) $(THUMB) -c -MMD -MP -MF"$(@:%.o=%.d)" -MT"$(@:%.o=%.d)" -o"$@" "$<"

# Pattern rule for cpp files
$(OBJDIR)/%.o:	%.cpp $(ALLDEP) $(OBJDIR)/%.d
	$(GPP) $(OPTS) $(DEBUGS) $(CPPFLAGS) $(DEFINES) $(THUMB) -c -MMD -MP -MF"$(@:%.o=%.d)" -MT"$(@:%.o=%.d)" -o"$@" "$<"

# Pattern rule for S files
$(OBJDIR)/%.o:	%.S $(ALLDEP) $(OBJDIR)/%.d
	$(GCC) $(OPTS) $(DEBUGS) $(CFLAGS) $(DEFINES) -c -o"$@" "$<"

