/*                                             ; fill-column:100 -*- mode:C++ -*-
  SFBInterrupts.h Support for user-level interrupt handling
  Copyright (C) 2009 The Regents of the University of New Mexico.  All rights reserved.

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301
  USA

  $Id$
*/

/**
  \file SFBInterrupts.h Support for user-level interrupt handling
  \author David H. Ackley.  
  \date (C) 2009 All rights reserved.
  \lgpl
 */

#ifndef SFBINTERRUPTS_H
#define SFBINTERRUPTS_H

#include "SFBTypes.h"
#include "SFBConstants.h"
#include "SFBPins.h"

extern void attachInterrupt(u32 sfbPin, IRQHandler *handlerFunction, u32 mode) ;

extern void detachInterrupt(u32 sfbPin) ;

extern bool canAttachInterrupt(u32 sfbPin) ;

extern bool hasAttachedInterrupt(u32 sfbPin) ;

#endif  /* SFBINTERRUPTS_H */
